import * as msRest from "@azure/ms-rest-js";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { LuisAuthoringContext } from "./luisAuthoringContext";
declare class LuisAuthoring extends LuisAuthoringContext {
    features: operations.Features;
    examples: operations.Examples;
    model: operations.Model;
    apps: operations.Apps;
    versions: operations.Versions;
    train: operations.Train;
    permissions: operations.Permissions;
    pattern: operations.Pattern;
    settings: operations.Settings;
    azureAccounts: operations.AzureAccounts;
    /**
     * Initializes a new instance of the LuisAuthoring class.
     * @param endpoint Supported Cognitive Services endpoints (protocol and hostname, for example:
     * https://westus.api.cognitive.microsoft.com).
     * @param credentials Subscription credentials which uniquely identify client subscription.
     * @param [options] The parameter options
     */
    constructor(endpoint: string, credentials: msRest.ServiceClientCredentials, options?: msRest.ServiceClientOptions);
}
export { LuisAuthoring, LuisAuthoringContext, Models as LuisAuthoringModels, Mappers as LuisAuthoringMappers };
export * from "./operations";
